#ifndef _SETUP_H
#define _SETUP_H

#include <QDialog>
#include <QFileDialog>
#include <QtGui/QIcon>
#include <QtWidgets/QApplication>
#include <QtWidgets/QComboBox>
#include <QtWidgets/QDialog>
#include <QtWidgets/QDoubleSpinBox>
#include <QtWidgets/QFrame>
#include <QtWidgets/QGridLayout>
#include <QtWidgets/QLabel>
#include <QtWidgets/QLineEdit>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QSpinBox>
#include <QtWidgets/QWidget>

QT_BEGIN_NAMESPACE
class QLabel;
QT_END_NAMESPACE

namespace Ui {
class Setup;
}

class Setup : public QDialog
{
    Q_OBJECT

public:
    explicit Setup(QWidget *parent = nullptr);
    ~Setup();
    bool loadFile(const QString &);

signals:
    void firstWindow();
    void setTitle(QString);

private slots:
    void on_openButton_clicked();
    void on_quitButton_clicked();
    void on_saveButton_clicked();
    void is_changed();

private:
    QByteArray logoByteArray;
    QImage image;
    QLabel *logoLabel;
    QLabel *breweryLabel;
    QLabel *fwhLabel;
    QLabel *mashhopLabel;
    QLabel *leafLabel;
    QLabel *pelletLabel;
    QLabel *hopplugLabel;
    QLabel *wethopLabel;
    QLabel *cryohopLabel;
    QLabel *extractLabel;
    QLabel *grainLabel;
    QLabel *brixLabel;
    QLabel *heightLabel;
    QLabel *titleLabel;
    QLabel *colorLabel;
    QLabel *ibuLabel;
    QLabel *waterLabel;
    QLabel *yeastLabel;

    QLineEdit *breweryEdit;

    QSpinBox *fwhEdit;
    QSpinBox *mashhopEdit;
    QDoubleSpinBox *pelletEdit;
    QDoubleSpinBox *hopplugEdit;
    QDoubleSpinBox *leafEdit;
    QDoubleSpinBox *wethopEdit;
    QDoubleSpinBox *cryohopEdit;
    QDoubleSpinBox *extractEdit;
    QComboBox *waterEdit;
    QDoubleSpinBox *grainEdit;
    QDoubleSpinBox *brixEdit;
    QSpinBox *heightEdit;
    QComboBox *colorEdit;
    QComboBox *ibuEdit;
    QComboBox *yeastEdit;
    QPushButton *quitButton;
    QPushButton *saveButton;
    QPushButton *openButton;

    double scaleFactor = 1;

    void setImage(const QImage &newImage);
    bool fieldIsChanged = false;
};

#endif
